using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RGDWCSServices.WCS
{
    public class startArrangeTask:HouseBase
    {
        /// <summary>
        /// 入参定义
        /// </summary>
        [Serializable]
        public class PARA
        {
            private string _wh_id;
            private string _equip_type;
            private string _task_no;
            private string _arrange_type;
            private List<LOCATION> _loc_list;

            /// <summary>
            /// 库房编号
            /// </summary>
            public string WH_ID
            {
                get { return this._wh_id; }
                set { this._wh_id = value; }
            }

            /// <summary>
            /// <para>设备类型</para>
            /// <para>下发库房的设备类型：01单相表 02三相表 03互感器 04采集终端 05周转箱 06通信模块。</para>
            /// </summary>
            public string EQUIP_TYPE
            {
                get { return this._equip_type; }
                set { this._equip_type = value; }
            }
            /// <summary>
            /// 任务号
            /// </summary>
            public string TASK_NO
            {
                get { return this._task_no; }
                set { this._task_no = value; }
            }
            /// <summary>
            /// 入库站台号
            /// </summary>
            public string ARRANGE_TYPE
            {
                get { return this._arrange_type; }
                set { this._arrange_type = value; }
            }

            public List<LOCATION> LOC_LIST
            {
                get { return this._loc_list; }
                set { this._loc_list = value; }
            }
        }

        /// <summary>
        /// 出参定义
        /// </summary>
        [Serializable]
        public class DATA : Base.OutPara
        {

        }

        /// <summary>
        /// 入参实体
        /// </summary>
        private PARA _inPara;

        /// <summary>
        /// 出参实体
        /// </summary>
        private DATA _outPara;

        /// <summary>
        /// 构造函数
        /// </summary>
        public startArrangeTask()
        {
            this._outPara = new DATA();
        }

        /// <summary>
        /// 通知
        /// </summary>
        /// <param name="sXmlIn">入参</param>
        /// <param name="sXmlOut">出参</param>
        /// <returns>执行结果</returns>
        public bool Notify(string sXmlIn, out string sXmlOut)
        {
            bool bResult = true;

            string sResult = string.Empty;

            sXmlOut = string.Empty;

            try
            {
                this._inPara = this.DeSerialize<PARA>(sXmlIn);

                bResult = null != this._inPara;

                if (!bResult)
                {
                    sResult = string.Format("入参错误（格式错误）");

                    return bResult;
                }

                bResult = this.STARTARRANGETASK(_inPara.WH_ID,_inPara.EQUIP_TYPE, _inPara.TASK_NO, _inPara.ARRANGE_TYPE, _inPara.LOC_LIST,sXmlIn, out sResult);
            }
            catch (Exception ex)
            {
                bResult = false;

                sResult = string.Format(ex.Message);
            }
            finally
            {
                if (bResult)
                {
                    this._outPara.RESULT_FLAG = Enum.RESULT_FLAG.Success.ToString("d");
                }
                else
                {
                    this._outPara.RESULT_FLAG = Enum.RESULT_FLAG.Fail.ToString("d");
                }

                this._outPara.ERROR_INFO = sResult;

                sXmlOut = this.Serializer<DATA>(this._outPara);
            }

            return bResult;
        }
    }
}
